// Gasdynamics.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Gasdynamics.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGasdynamicsApp

BEGIN_MESSAGE_MAP(CGasdynamicsApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGasdynamicsApp construction

CGasdynamicsApp::CGasdynamicsApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CGasdynamicsApp object
class Proc2D;
class Proc3D;
class ProcStereo;

CGasdynamicsApp theApp;


	double U1[4][NX_MAX][NY_MAX];
	double V[4][NX_MAX];
	double F[4][NX_MAX],P[NX_MAX];
	double D[4][NX_MAX],Dg[4][NX_MAX],A[4][NX_MAX],B[4][NX_MAX],R[4][4][NX_MAX];
	double Vgas[4];
	double Hx,Hy,Hmin,CFL;
	double G,G0,G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,G12;
	double U0,P0,R0,E0,Ce,Uchap,Utest,Ptest,Rtest,Etest;
	double Time, Lx,Ly,Lt,Lt0;
	int Nx,Ny,Mx,My,Jt,Nout, KeyOut;
	int Nx_,Ny_,Mx_,My_,iOut;

	CString methodTitle;
	METHOD_TYPE eMethodType;

	int	mNx,mNy; //  
	int	m_NClr;
	int	Nc;
	int Jtu;

	int		mask[NX_MAX][NY_MAX];

	enum	_KEY_PROCESS Key_process;

	Proc2D* p2D[NF];
	Proc3D* p3D[NF];
	ProcStereo* pStereo[NF];

//	matrix       3D 
double	matrix[NF][NX_MAX][NY_MAX];

// m_Range       
double	m_Range[NF][2];	

BOOL bRunRequest, bInitCalculations = false, bRepaint = false;

/////////////////////////////////////////////////////////////////////////////
// CGasdynamicsApp initialization

BOOL CGasdynamicsApp::InitInstance()
{
#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	//// Parse command line for standard shell commands, DDE, file open
	//CCommandLineInfo cmdInfo;
	//ParseCommandLine(cmdInfo);

	//// Dispatch commands specified on the command line
	//if (!ProcessShellCommand(cmdInfo))
	//	return FALSE;

	// The main window has been initialized, so show and update it.
//	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->ShowWindow(SW_SHOWMAXIMIZED);
//	pMainFrame->UpdateWindow();

	pMainFrame->FirstShow();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	enum { IDD = IDD_ABOUTBOX };
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedButtonUrl();
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_URL, &CAboutDlg::OnBnClickedButtonUrl)
END_MESSAGE_MAP()

// App command to run the dialog
void CGasdynamicsApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CAboutDlg::OnBnClickedButtonUrl()
{
	::ShellExecute (NULL, 0, "http://byvshikh.narod.ru/gasdynamics/", 0, 0, SW_SHOWNORMAL);
}
