#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Data.h : header file
//

class CMainFrame;

/////////////////////////////////////////////////////////////////////////////
// Data thread

class Data : public CWinThread
{
	DECLARE_DYNCREATE(Data)

public:
	Data();
	CMainFrame* pParent;

	void SetOwner(CMainFrame* pOwner) { pParent = pOwner; };
	virtual BOOL InitInstance();

protected:
	double	Ht,HtHx,HtHy;
	double	Oa,Ob,Oc,Od,Oe;
	CString s, Error;
	
	void Inject(int x1,int x2,int y1,int y2,
				double O1,double O2,double O3,double O4);
	void Def_Ht();
	void Free_X(int Ymin,int Ymax,int x, DUMMY_BORDER_POS border_pos);
	void Wall_X(int Ymin,int Ymax,int x, DUMMY_BORDER_POS border_pos,WALL_BORDER_POS wall_pos);
	void Wall_Y(int Xmin,int Xmax,int y, DUMMY_BORDER_POS border_pos,WALL_BORDER_POS wall_pos);

	void Proc_Y(int Xmin,int Xmax, int Ymin,int Ymax);
	void Proc_X(int Xmin,int Xmax, int Ymin,int Ymax);

	void God_X(int Xmin,int Xmax, int Ymin,int Ymax);
	void God_Y(int Xmin,int Xmax, int Ymin,int Ymax);

	void LW_X (int Xmin,int Xmax, int Ymin,int Ymax);
	void LW_Y (int Xmin,int Xmax, int Ymin,int Ymax);

	void Har_X(int Xmin,int Xmax, int Ymin,int Ymax);
	void Har_Y(int Xmin,int Xmax, int Ymin,int Ymax);

	void FFp(double P,double Pk,double Rk,
			 double* F,double* Fp);

	void Rarefaction(double Pr,double Rr,double Ur,
					 double* P,double* R,double* U);

	void Riemann(double Pl, double Rl, double Ul,
				 double Pr, double Rr, double Ur,
				 double* Pc,double* Rc,double* Uc, int* iter);

	DECLARE_MESSAGE_MAP()
};