// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Data.h"
class SheetDialog;

extern	int	m_NClr;
//UINT	Rotate(LPVOID pParam);
/////////////////////////////////////////////////////////////////////////////
class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

	Data* pData;
	BOOL bExecuteOnButtonPaint;
	SheetDialog*	pSheetDialog;

void Show();
inline COLORREF GetColor(int N)
		{ return ( (m_clr[N]).color[m_NClr] ); };

void SetIsolLevels();
void UpdateTitle();
void Isoline(CDC* m_dc, CRect* rectClient, enum JC_GAS Jg, SIZE size);
void Surface(CDC* m_dc, CRect* rcClient, enum JC_GAS Jg, int n3DS, int add_angle);

int	n2D3DS_create;	// n   
					//  : 1-1D, 2-2D, 3-3D, 4-Stereo 

int	n3DS_rotate;	// n     
					//  : 3-3D, 4-Stereo

enum JC_GAS Jc_Wnd; // Jg      

int		nType;  // .  ,     

BOOL bTitle;	//     
				//       
				//      

BOOL bMainFirst;//    WM_ACTIVATEAPP
 
BOOL bRotate;	//    
				//      
 				//      

int	 nDirection; //  

int	 baza;		//    
				//  

void Rotate(BOOL go);

protected:
	void FillMatrix();

double	Scale3D;	//     3D  Stereo
double  ScaleStereo;

void SetColorArray();
inline double GetLevels(int M, enum JC_GAS Jg)
				{ return ((Jc_Levels[M]).Levels[Jg]); };
BOOL IsolSingle(CDC* m_dc, double dXmin,  double dXmax,
						   double dYmin,  double dYmax,
						   double y00,	  double y01,
						   double y10,	  double y11,
						   BOOL empty,	  enum JC_GAS Jg,
						   int size_cy);
void UpdateAxis(enum JC_GAS Jg, int add);
void UpdatePointObj(enum JC_GAS Jg);
void AxisDraw(CDC* pDC);
void MatrixDraw(CDC* pDC, enum JC_GAS Jg, int add);
void CheckWindow(enum JC_GAS Jg, int n2D3DS_create, BOOL b);

//------- colors -------
typedef struct _ARRAY_COLOR
{
	COLORREF color[2];
} ARRAY_COLOR;

CArray<ARRAY_COLOR,ARRAY_COLOR> m_clr;//   

CBrush* pBrush[MAXCOLOR];	//   
CPen*	pPen[4];			//  

COLORREF	dwColor[4];		//   3D  (,  )
//------- pics levels -------
CArray<double,double> Levels;

typedef struct _ARRAY_LEVELS
{
	double Levels[NF];
} ARRAY_LEVELS;

CArray<ARRAY_LEVELS,ARRAY_LEVELS> Jc_Levels;//   . 
//----------------------
POINT	m_Point[NF][NY_MAX][NX_MAX];//    

//	m_Point; //      POINT
	//     
	//e.x. POINT m_Point[Y][X];

//    :
int be, //     Z
	al; //   Z ()

//   : 
POINT	center;	//   
SIZE	size;	//  CClientDC  
int		l_x, l_y, l_z; //    

//      :
		//    (   )
POINT	p_x, p_y, p_z;
		//   X=0,Y=0, Z=0 ( )
POINT	p_xy0beg;
		//    X 
		//( X=max, Y=0, Z=0   )
POINT	p_x0end;
		//    Y
		//( X=0, Y=max, Z=0   )
POINT	p_y0end;
		//   X=0, Y=0, Z=min (  )
POINT	c;

double	m_Sdegree;	//     ( =1)
double	dbe, dal;	//    
RECT	rectDefault;//   


public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

	void FirstShow();
	BOOL bFirstRun;
	void InitCalculations();

static	HANDLE	m_hRunRequest;
static	HANDLE	m_hEventNeedNotDC;

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	CToolBar    m_wndToolBar;

protected:
	CStatusBar  m_wndStatusBar;
	BOOL IsInGas(int ix, int iy);

	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButtonGo();
	afx_msg void OnButtonInit();
	afx_msg void OnButtonR();
	afx_msg void OnButtonP();
	afx_msg void OnButtonE();
	afx_msg void OnButtonM();	
	afx_msg void OnButtonH();
	afx_msg void OnButtonS();	
	afx_msg void OnButtonU();
	afx_msg void OnButtonUx();
	afx_msg void OnButtonUy();
	afx_msg void OnButton2D();
	afx_msg void OnButton3D();
	afx_msg void OnButtonStereo();
	afx_msg void OnButtonColor();
	afx_msg void OnButtonInc();
	afx_msg void OnButtonDec();
	afx_msg void OnButtonUp();
	afx_msg void OnButtonDown();
	afx_msg void OnButtonLeft();
	afx_msg void OnButtonRight();
	afx_msg void OnButtonPause();
	afx_msg void OnButtonPaint();
	afx_msg void OnButtonTools();
	afx_msg LRESULT OnTitle(WPARAM wParam = 0, LPARAM lParam = 0);
	DECLARE_MESSAGE_MAP()
};
