// PaneStereo.cpp : implementation file
//

#include "stdafx.h"
#include "Gasdynamics.h"
#include "MainFrm.h"
#include "ProcStereo.h"
#include "PaneStereo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	ProcStereo* pStereo[NF];
extern int Nc;
extern double Lx,Ly;
/////////////////////////////////////////////////////////////////////////////
// PaneStereo

IMPLEMENT_DYNCREATE(PaneStereo, CView)

PaneStereo::PaneStereo()
{
}

BEGIN_MESSAGE_MAP(PaneStereo, CView)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_SETFOCUS()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// PaneStereo drawing

void PaneStereo::OnDraw(CDC* pDC)
{
//	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// PaneStereo diagnostics

#ifdef _DEBUG
void PaneStereo::AssertValid() const
{
	CView::AssertValid();
}

void PaneStereo::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// PaneStereo message handlers
//---------------------------------------------------------------------------
void PaneStereo::InitPicBoxStereo()
{
//	if (m_dc) 
//	{
//		AfxMessageBox("PaneStereo::InitPicBoxStereo: m_dc  ");
//		return;
//	}

	CClientDC dc(this);

	if(!m_dc.CreateCompatibleDC(NULL))
		AfxMessageBox("InitPicBoxStereo: !m_dc.CreateCompatibleDC(NULL)");

	BITMAP bm;
	bm.bmType      = 0;
	bm.bmWidth     = dc.GetDeviceCaps(HORZRES);
	bm.bmHeight    = dc.GetDeviceCaps(VERTRES);
	bm.bmPlanes    = dc.GetDeviceCaps(PLANES);
	bm.bmBitsPixel = dc.GetDeviceCaps(BITSPIXEL);
	bm.bmBits      = NULL;
	bm.bmWidthBytes  = (int)bm.bmBitsPixel*bm.bmWidth/8 + 2;

	if(!bitmap.CreateBitmapIndirect(&bm))
		AfxMessageBox("PaneStereo::InitPicBoxStereo:\n!bitmap.CreateBitmapIndirect(&bm)");

	pOldBitmap = m_dc.SelectObject(&bitmap);
}
//---------------------------------------------------------------------------
void PaneStereo::PicBox()
{
	if (m_dc)
	{
		((ProcStereo*)pStereo[Jg])->center.x = center.x;
		((ProcStereo*)pStereo[Jg])->center.y = center.y;

		GetClientRect(rcClient);
		size = rcClient.Size();

		((CMainFrame*)m_pParent)->Surface(&m_dc, &rcClient,Jg,4,add_angle);

		CClientDC dc(this);
		dc.BitBlt(0, 0, size.cx, size.cy, &m_dc, 0, 0, SRCCOPY);
	}
}
//---------------------------------------------------------------------------
void PaneStereo::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	dc.BitBlt(0, 0, size.cx, size.cy, &m_dc, 0, 0, SRCCOPY);
}
//---------------------------------------------------------------------------
void PaneStereo::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (nFlags!=MK_LBUTTON)
	{
		switch ( Direction(point) )
		{
			case 1: { SetCursor(AfxGetApp()->LoadCursor(IDC_UP));   break; }
			case 2: { SetCursor(AfxGetApp()->LoadCursor(IDC_LEFT)); break; }
			case 3: { SetCursor(AfxGetApp()->LoadCursor(IDC_RIGHT));break; }
			case 4: { SetCursor(AfxGetApp()->LoadCursor(IDC_DOWN)); break; }
		}
	}
	else
	{
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_SIZEALL));
		((ProcStereo*)pStereo[Jg])->displacement.x += point.x - oldPoint.x;
		((ProcStereo*)pStereo[Jg])->displacement.y += point.y - oldPoint.y;
		oldPoint = point;
		((ProcStereo*)pStereo[Jg])->PicBox();
	}

	CView::OnMouseMove(nFlags, point);
}
//---------------------------------------------------------------------------
BOOL PaneStereo::Create(LPCTSTR lpszClassName,
					   LPCTSTR lpszWindowName,
					   DWORD dwStyle,
					   const RECT& rect,
					   CWnd* pParentWnd,
					   UINT nID, 
					   CCreateContext* pContext) 
{
	m_pParent = AfxGetMainWnd();

	LPCTSTR lpszBounceClass =
		AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW, 
			NULL,(HBRUSH)(COLOR_WINDOW+1),NULL);

	return CWnd::Create(lpszBounceClass,
						lpszWindowName,
						dwStyle,
						rect,
						pParentWnd,
						nID,
						pContext);
}
//---------------------------------------------------------------------------
void PaneStereo::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);

	if (nType != SIZE_MINIMIZED)
	{
		PicBox();
	//	OnPaint();
	}
}
//---------------------------------------------------------------------------
void PaneStereo::OnLButtonDown(UINT nFlags, CPoint point) 
{
	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_SIZEALL));
	oldPoint = point;
	
	CView::OnLButtonDown(nFlags, point);
}
//---------------------------------------------------------------------------
void PaneStereo::OnRButtonDown(UINT nFlags, CPoint point) 
{
	if (nFlags != MK_LBUTTON)
	{
		Direction(point);

		//   
		((CMainFrame*)m_pParent)->Rotate(TRUE);
	}
	CView::OnRButtonDown(nFlags, point);
}
//---------------------------------------------------------------------------
void PaneStereo::OnLButtonUp(UINT nFlags, CPoint point) 
{
	switch ( Direction(point) )
	{
		case 1: {	SetCursor(AfxGetApp()->LoadCursor(IDC_UP));   break; }
		case 2: {	SetCursor(AfxGetApp()->LoadCursor(IDC_LEFT)); break; }
		case 3: {	SetCursor(AfxGetApp()->LoadCursor(IDC_RIGHT));break; }
		case 4: {	SetCursor(AfxGetApp()->LoadCursor(IDC_DOWN)); break; }
	}	
	
	CView::OnLButtonUp(nFlags, point);
}
//---------------------------------------------------------------------------
void PaneStereo::OnRButtonUp(UINT nFlags, CPoint point) 
{
	//   
	((CMainFrame*)m_pParent)->Rotate(false);
	
	CView::OnRButtonUp(nFlags, point);
}
//---------------------------------------------------------------------------
int PaneStereo::Direction(CPoint point)
{
//	  \  1  /
//		\ /
//	  2	 x  3
//      / \
//    /  4  \
//
int n;
POINT	p = ((ProcStereo*)pStereo[Jg])->cursor_center;

if ( point.y > (p.y + (point.x-p.x)) )
{//2,4
	if ( point.y > (p.y-(point.x-p.x)) ) n = 4;
	else								 n = 2;
}
else
{//1,3
	if ( point.y > (p.y-(point.x-p.x)) ) n = 3;
	else								 n = 1;
}
	((CMainFrame*)m_pParent)->nDirection = n;
	return n;
}
//---------------------------------------------------------------------------
void PaneStereo::OnSetFocus(CWnd* pOldWnd) 
{
	CView::OnSetFocus(pOldWnd);
	
CString s;
s.Format("  Pane>>>Pane::OnSetFocus  this=%d\n",this);
TRACE0(s);
}
//---------------------------------------------------------------------------
