#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CMainFrame;
/////////////////////////////////////////////////////////////////////////////
// Proc3D frame

class Proc3D : public CMDIChildWnd
{
public:
	Proc3D();

	DECLARE_DYNCREATE(Proc3D)

public:
	virtual BOOL Create(LPCTSTR szTitle, LONG style,const RECT& rect,CMDIFrameWnd* parent,enum JC_GAS J);
	virtual BOOL DestroyWindow();
protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);


public:
	virtual ~Proc3D();
	void PicBox();
	CDC m_dc;

	// from CMainFrame
	int	l_x, l_y, l_z;	//    
	SIZE  size;
	POINT cursor_center;//      
	POINT center;		//   
	POINT displacement;	//   
protected:
	CWnd*		m_pParent;
	CWinThread*	pRotate;
	enum JC_GAS Jg;

	CBitmap bitmap;
	CBitmap *pOldBitmap;
	CRect rcClient;
	POINT oldPoint;
	SIZE  oldSize;
	BOOL  bFirstFocus;	

	int Direction(CPoint point);

	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnNcLButtonDown(UINT nHitTest, CPoint point);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	DECLARE_MESSAGE_MAP()
};
