// SheetDialog.cpp : implementation file
//

#include "stdafx.h"
#include "gasdynamics.h"
#include "SheetDialog.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SheetDialog dialog


SheetDialog::SheetDialog(CWnd* pParent /*=NULL*/)
	: CDialog(SheetDialog::IDD, pParent)
{
	m_pParent = pParent;
}

void SheetDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(SheetDialog, CDialog)
	ON_WM_CLOSE()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SheetDialog message handlers

BOOL SheetDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_dlgPropSheet.AddPage(&m_Tool0);
	m_dlgPropSheet.AddPage(&m_Tool1);


	m_dlgPropSheet.Create(this, WS_CHILD | WS_VISIBLE, 0);
	m_dlgPropSheet.ModifyStyleEx (0, WS_EX_CONTROLPARENT);
//	m_dlgPropSheet.ModifyStyle( 0, WS_TABSTOP );

	CRect rcSheet;
	GetDlgItem( IDC_PROPSHEET )->GetWindowRect( &rcSheet );
	ScreenToClient( &rcSheet );
	m_dlgPropSheet.SetWindowPos( NULL, rcSheet.left-7, rcSheet.top-7, 0, 0, 
			SWP_NOZORDER | SWP_NOSIZE | SWP_NOACTIVATE );

	this->SetWindowText(methodTitle);
	((CMainFrame*) m_pParent)->SetWindowText(methodTitle);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
//---------------------------------------------------------------------------
void SheetDialog::UpdateDialogs()
{
	this->SetWindowText(methodTitle);
	((CMainFrame*) m_pParent)->SetWindowText(methodTitle);

	if (m_dlgPropSheet.GetActiveIndex()==m_dlgPropSheet.GetPageIndex(&m_Tool0))		 m_Tool0.UpdateDialog();
//	else if (m_dlgPropSheet.GetActiveIndex()==m_dlgPropSheet.GetPageIndex(&m_Tool1)) m_Tool1.UpdateDialog();
}
//---------------------------------------------------------------------------
void SheetDialog::OnOK() 
{
	this->SetWindowText(methodTitle);
	CDialog::OnOK();
}
//---------------------------------------------------------------------------
void SheetDialog::OnClose() 
{
	this->SetWindowText(methodTitle);
	CDialog::OnClose();
}
//---------------------------------------------------------------------------
