#if _MSC_VER > 1000
#pragma once
#endif

#define _USE_MATH_DEFINES
#include <math.h>

#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers

#include <afxwin.h>         // MFC core and standard components
#include <afxext.h>         // MFC extensions
#ifndef _AFX_NO_AFXCMN_SUPPORT
#include <afxcmn.h>			// MFC support for Windows Common Controls
#endif // _AFX_NO_AFXCMN_SUPPORT
#include <afxtempl.h>
#include <afxmt.h>
#include <float.h>

enum JC_GAS //R P E M H S U Ux Uy
{
	Jg_R,
	Jg_P,
	Jg_E,
	Jg_M,
	Jg_H,
	Jg_S,
	Jg_U,
	Jg_Ux,
	Jg_Uy
};

enum METHOD_TYPE
{
	MT_GODUNOV,
	MT_LW,
	MT_HARTEN
};

enum DUMMY_BORDER_POS
{
	DUMMY_AT_LEFT,
	DUMMY_AT_RIGHT,
	DUMMY_AT_BOTTOM,
	DUMMY_AT_TOP
};

enum WALL_BORDER_POS
{
	WALL_AT_MESH_POINT,
	WALL_BETWEEN_MESH_POINTS
};

#define PM_TITLE (WM_USER + 0x1000)

#define NF 9 //       
			 // R P E M H S U Ux Uy

//		NX_MAX>=NY_MAX  <-<<      . 
#define NX_MAX 244 //      X  Y
#define NY_MAX 84

#define MAXCOLOR 16	// MAXCOLOR -       
